#include "FC2720.h"

#define  COM1_BIT    0x01
#define  COM1_ODR    P3
#define  COM1_DDR    P3M
#define  COM1_H      COM1_ODR|=COM1_BIT
#define  COM1_L      COM1_ODR&=~COM1_BIT
#define  COM1_OUT    COM1_DDR|=COM1_BIT
#define  COM1_IN     COM1_DDR&=~COM1_BIT

#define  COM2_BIT    0x04
#define  COM2_ODR    P1
#define  COM2_DDR    P1M
#define  COM2_H      COM2_ODR|=COM2_BIT
#define  COM2_L      COM2_ODR&=~COM2_BIT
#define  COM2_OUT    COM2_DDR|=COM2_BIT
#define  COM2_IN     COM2_DDR&=~COM2_BIT

#define  COM3_BIT    0x04
#define  COM3_ODR    P3
#define  COM3_DDR    P3M
#define  COM3_H      COM3_ODR|=COM3_BIT
#define  COM3_L      COM3_ODR&=~COM3_BIT
#define  COM3_OUT    COM3_DDR|=COM3_BIT
#define  COM3_IN     COM3_DDR&=~COM3_BIT

#define  COM4_BIT    0x08
#define  COM4_ODR    P3
#define  COM4_DDR    P3M
#define  COM4_H      COM4_ODR|=COM4_BIT
#define  COM4_L      COM4_ODR&=~COM4_BIT
#define  COM4_OUT    COM4_DDR|=COM4_BIT
#define  COM4_IN     COM4_DDR&=~COM4_BIT

#define  COM5_BIT    0x10
#define  COM5_ODR    P3
#define  COM5_DDR    P3M
#define  COM5_H      COM5_ODR|=COM5_BIT
#define  COM5_L      COM5_ODR&=~COM5_BIT
#define  COM5_OUT    COM5_DDR|=COM5_BIT
#define  COM5_IN     COM5_DDR&=~COM5_BIT

#define  COM6_BIT    0x20
#define  COM6_ODR    P3
#define  COM6_DDR    P3M
#define  COM6_H      COM6_ODR|=COM6_BIT
#define  COM6_L      COM6_ODR&=~COM6_BIT
#define  COM6_OUT    COM6_DDR|=COM6_BIT
#define  COM6_IN     COM6_DDR&=~COM6_BIT

#define BIT_A    0x01
#define BIT_B    0x02
#define BIT_C    0x04
#define BIT_D    0x08
#define BIT_E    0x10
#define BIT_F    0x20
#define BIT_G    0x40

 //ģ,ROM
uint8_t DigTable[13]=
{
  0X3F,  //0       0
  0X06,  //1       1
  0X5B,  //2       2
  0X4F,  //3       3
  0X66,  //4       4
  0X6D,  //5       5
  0X7D,  //6       6
  0X07,  //7       7
  0X7F,  //8       8
  0X6F,  //9       9
  0X00,  //10      ո
  0X40,  //11      -
  0X73,  //12      ĸP
};
bit       bit250us=0;
bit       bit1ms=0;
bit       bit10ms=0;
bit       bit50ms=0;

bit       bitToggle=0;
bit       bitGetAdFinish=0;
bit       bitDP1=1;
bit       bitDP2=1;

uint8_t u8DigShow1=8;
uint8_t u8DigShow2=8;
uint8_t u8DigShow3=8;

uint8_t u8Codetmp1=0xFF;
uint8_t u8Codetmp2=0xFF;
uint8_t u8Codetmp3=0xFF;

uint8_t u8DigShow1Now=0;
uint8_t u8DigShow2Now=0;
uint8_t u8DigShow3Now=0;

uint16_t u16AdcFilterValue=0;
uint16_t  voltageNow=0;
//uint8_t u8adcFilter=38;
//uint16_t u16limit=4096;

/*Function statment<<=========================================================*/
void display_ctr(void);
void system_init(void);
void get_voltage(void);
//void get_adc(void);
void t0_enable(void);
void adc_init(void);
//void delay_1ms(uint8_t x_1ms);
/******************************************************************************************************
*      ƣжϷ
*      ܣֻ
*  ڲ
*  ڲ
*      ڣ2019.6.14
*      ߣм
******************************************************************************************************/
void __interrupt[0x8] isr(void)
{ 
    static uint8_t j=0;
  if(FT0IF)
  {
  //  P3^=0x80;

    T0C=68;      //װ??        
    j++;
    bit250us=1;

    //if(j>3)  
   // {
    //  j=0;
   //   bit1ms=1; 
    //  i++;
//      x++;

   // }  

    if(j>39)
    {
      j=0;  
      bit10ms=1;     
    }
    
   // if(x>49)
   // {
   //   x=0;
   //   bit50ms=1;
    //}  
    FT0IF=0;//жϱ־λ

  }
}
/******************************************************************************************************
*      ƣ
*      ܣ
*  ڲ   
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void main(void)
{
   // uint16_t x=0;
    //system_init();
	adc_init();
	t0_enable();
    // for(x=0;x<1400;x++)
    // {
      // delay_1ms(1);
      // display_ctr();
	// }
    while(1)
    {
      if(bit250us)
      {
        bit250us=0;   
        display_ctr();          
      }
      
      //if(bit1ms)
      //{
      //  bit1ms=0;  
     // }
      
      if(bit10ms)
      {
        bit10ms=0; 
        WDTR=0x5A;     
        get_voltage();       
      }       
	}
}
/******************************************************************************************************
*      :ʼADC
*      ܣ
*  ڲ   
*  ڲ
*      ڣ2019.9.28
*      ߣ
******************************************************************************************************/
void adc_init(void)
{
//  P3M &=0xBF;
  ADPCON=0x40;   
  ADR=0x00;          //   
  VREFH=0x00;        //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADM  =0x96;        //AIN6 P36 ΪAD
} 
/*****************************************************************************************************
*      ܣʾ
*  ڲ   
*  ڲ
*      ڣ202099
*      ߣм
******************************************************************************************************/
void all_com_in(void)
{
  COM1_IN;
  COM2_IN;  
  COM3_IN;
  COM4_IN;  
  COM5_IN;
  COM6_IN;
}

/******************************************************************************************************
*      ܣʾ
*  ڲu8DigShow1  u8DigShow2  u8DigShow3  bitDP1  bitDP2
*  ڲ
*  ˵    
*      
*      ڣ2020.9.10
*      ߣ
******************************************************************************************************/
void com1_enable(void)
{
  COM1_H;
  COM1_OUT;    
}  
void com2_enable(void)
{
  COM2_H;
  COM2_OUT;    
} 
void com3_enable(void)
{
  COM3_H;
  COM3_OUT;    
} 
void com4_enable(void)
{
  COM4_H;
  COM4_OUT;    
} 
void com5_enable(void)
{
  COM5_H;
  COM5_OUT;    
} 
 
void com6_enable(void)
{
  COM6_H;
  COM6_OUT;    
}
  
void display_ctr(void)
{
  static  uint8_t u8DisplayDriveStep=0;
  static  uint16_t x=0;

  u8Codetmp1=DigTable[u8DigShow1];//λ  
  u8Codetmp2=DigTable[u8DigShow2];//ʮλ
  u8Codetmp3=DigTable[u8DigShow3];//λ
  
  if(x<6000)
  { 
    x++;
//	u8adcFilter=8;  
//	u16limit=4096;   
  }
  else
  {
	u8DigShow1=u8DigShow1Now;
	u8DigShow2=u8DigShow2Now;
    u8DigShow3=u8DigShow3Now;   
//    u8adcFilter=38;   
//	u16limit=400; 
    if(u16AdcFilterValue<1280)
    {
//128000
	  bitDP2=0;
	  bitDP1=1;
    }
    else
    {
	  bitDP1=0;
	  bitDP2=1;
    }   
  }
  
  all_com_in();   
  switch(u8DisplayDriveStep)
  {  
    case 0://1A
    {    
      if(u8Codetmp1&BIT_A)
      {
        COM3_L;
        COM3_OUT;
        com2_enable();  
      }
    }   
    break;
    
    case 1://1B
    {
      if(u8Codetmp1&BIT_B)
      {
        COM4_L;
        COM4_OUT;
        com2_enable();         
      }
    }  
    break;
    
    case 2://1C
    {
      if(u8Codetmp1&BIT_C)
      {
        COM2_L;
        COM2_OUT;
        com5_enable();         
      }
    }     
    break;  

    case 3://1D
    {
      if(u8Codetmp1&BIT_D)
      {
        COM6_L;
        COM6_OUT;
        com2_enable();         
      } 
    }     
    break;   

      
    case 4://1E
    {
      if(u8Codetmp1&BIT_E)
      {
        COM5_L;
        COM5_OUT;
        com2_enable();         
      }
    }  
    break;   
	
      
    case 5://1F
    {
      if(u8Codetmp1&BIT_F)
      {
        COM2_L;
        COM2_OUT;
        com3_enable();         
      }  
    }  
    break;

    case 6://1G
    {
      if(u8Codetmp1&BIT_G)
      {
        COM2_L;
        COM2_OUT;
        com4_enable();         
      }
    }  
    break; 

    case 7://1DP
    {
      if(bitDP1)
      {
        COM1_L;
        COM1_OUT;
        com2_enable();         
      } 
    }  
    break;     

    case 8://2A
    {

      if(u8Codetmp2&BIT_A)
      {
        COM4_L;
        COM4_OUT;
        com5_enable();         
      }     
    }  
    break; 

    case 9://2B
    {
      if(u8Codetmp2&BIT_B)
      {
        COM5_L;
        COM5_OUT;
        com3_enable();         
      }
    }  
    break;  

    case 10://2C
    {
      if(u8Codetmp2&BIT_C)
      {
        COM5_L;
        COM5_OUT;
        com4_enable();         
      } 
    }  
    break; 

    case 11://2D
    {
      if(u8Codetmp2&BIT_D)
      {
        COM4_L;
        COM4_OUT;
        com3_enable();         
      } 
    }  
    break;  

    case 12://2E
    {
      if(u8Codetmp2&BIT_E)
      {
        COM3_L;
        COM3_OUT;
        com6_enable();         
      }
    }  
    break; 

    case 13://2F
    {
      if(u8Codetmp2&BIT_F)
      {
        COM3_L;
        COM3_OUT;
        com4_enable();         
      } 
    }  
    break;    

    case 14://2G
    {
      if(u8Codetmp2&BIT_G)
      {
        COM3_L;
        COM3_OUT;
        com5_enable();         
      } 
    }  
    break;    

    case 15://2DP
    {
      if(bitDP2)
      {
        COM1_L;
        COM1_OUT;
        com3_enable();         
      } 
    }  
    break; 

    case 16://3A
    {
      if(u8Codetmp3&BIT_A)
      {
        COM6_L;
        COM6_OUT;
        com1_enable();         
      }
    }  
    break; 

    case 17://3B
    {
      if(u8Codetmp3&BIT_B)
      {
        COM6_L;
        COM6_OUT;
        com3_enable();         
      }   
    }  
    break;  

    case 18://3C
    {
      if(u8Codetmp3&BIT_C)
      {
        COM6_L;
        COM6_OUT;
        com5_enable();         
      }
    }  
    break; 

    case 19://3D
    {
      if(u8Codetmp3&BIT_D)
      {
        COM4_L;
        COM4_OUT;
        com6_enable();         
      }  
    }  
    break;  

    case 20://3E
    {  
      if(u8Codetmp3&BIT_E)
      {
        COM6_L;
        COM6_OUT;
        com4_enable();         
      }
    }  
    break; 

    case 21://3F
    {
      if(u8Codetmp3&BIT_F)
      {
        COM5_L;
        COM5_OUT;
        com6_enable();         
      }
    }  
    break;    

    case 22://3G
    {
      if(u8Codetmp3&BIT_G)
      {
        COM5_L;
        COM5_OUT;  
        com1_enable();         
      }
    }  
    break;           
  } 
  u8DisplayDriveStep++;
  if(u8DisplayDriveStep>22)
  u8DisplayDriveStep=0;       
} 
/******************************************************************************************************
*      : get_adc 
*      ܣѯADCתģʽ,жģʽ
*  ڲ   
*  ڲ
*      ڣ2018.1.4
*      ߣ
******************************************************************************************************/
#if 0
void get_adc(void)
{
  static uint8_t cnt=0;
  static uint16_t u16AdcNow=0;
 
  //while(FADS);             //ȴADCת
  u16AdcNow=ADB;
  u16AdcNow<<=4;
  u16AdcNow+=(ADR&0x0F);

  //FEOC=0;                //ADC״̬־λ׼һADC   
  u16AdcFilterValue=(u16AdcFilterValue*7+u16AdcNow)/8;
  bitGetAdFinish=1;
  /*if(u16AdcFilterValue!=u16AdcNow)
  {
    cnt++;       //ۼ
    if(cnt>32)   //
    {
	  cnt=0;
      bitGetAdFinish=1;  
      		
	  u16AdcFilterValue=u16AdcNow;  	//8βһ£ADֵ  
    }	  
  }
  else
  {
    cnt=0; 
  }
  */

}
#endif
/******************************************************************************************************
*      : 
*      ܣѹֵ
*  ڲ   
*  ڲ
*      ڣ2020.9.9
*      ߣ
******************************************************************************************************/
void get_voltage(void)
{
  static uint8_t cnt=0;
  static uint8_t count=0;
  static uint16_t u16AdcNow=0;
  static uint16_t max=0;
  static uint16_t min=0;
  static uint16_t minddle=0;
 
    //while(FADS);             //ȴADCת
  u16AdcNow=ADB;
  u16AdcNow<<=4;
  u16AdcNow+=(ADR&0x0F);

  if(bitGetAdFinish)                      //u8Step=2;
  {
    bitGetAdFinish=0;    
    if(u16AdcFilterValue<1280)
	{
//128000
      voltageNow=25*u16AdcFilterValue;
	  //voltageNow=voltageNow/32;
	  voltageNow=voltageNow>>5;
	}
	else
	{
      voltageNow=10*u16AdcFilterValue;
	  //voltageNow=voltageNow/128;
	  voltageNow=voltageNow>>7;
	} 
    u8DigShow1Now =voltageNow/100;
    u8DigShow2Now =voltageNow%100/10;
    u8DigShow3Now =voltageNow%10;	
  }

  //FEOC=0;                //ADC״̬־λ׼һADC   
  if(u16AdcFilterValue!=u16AdcNow)
  {
    cnt++;       //ۼ
    if(cnt>42)   //
    {
	  count++;
	  if(count>2)
	  count=0;
	  switch(count)
	  {
	    case 0:
        max=u16AdcNow;
		min=u16AdcNow;
		break;

		case 1:
        if(u16AdcNow>max)
		max=u16AdcNow;

        if(min>u16AdcNow)
		min=u16AdcNow;
		break;

		case 2:
        if(max<u16AdcNow)
		u16AdcNow=max;

		if(u16AdcNow<min)
		u16AdcNow=min;
	    cnt=0;  
        bitGetAdFinish=1;  
	    u16AdcFilterValue=u16AdcNow;  	//8βһ£ADֵ 
		break;
	  }
    }	  
  }
  else
  {
    cnt=0; 
  }
  FADS =1;                 //ʼADCת 
}
/******************************************************************************************************
*      : void t0_enable(void)
*      ܣt0
*  ڲ
*  ڲ
*      ڣ2019.10.12
*      ߣ
******************************************************************************************************/
void t0_enable(void)
{
  T0M=0xD0;      //T0TR T0PS2 T0PS1 T0PS0 - - - -   000,Fcpu/256 001/128 010/64 011/32 100/16 101/8 110/4 111/2
  //T0C=68;        //
  FT0IE=1;       //T0ж
  FGIE=1;
}
/******************************************************************************************************
*      ƣvoid delay_1ms(uint8_t x_1ms)
*      ܣʱ x_1ms ,ϵͳƵΪ12M/4
*  ڲx_1ms    
*  ڲ
*      ڣ2017.11.14
*      ߣм
******************************************************************************************************/
/*void delay_1ms(uint8_t x_1ms)
{
  uint8_t i=0;
  for(;x_1ms>0;x_1ms--)
  {
    for(i=249;i>0;i--)
	{
      __asm{nop};
	  __asm{nop};
	  __asm{nop};
	  __asm{nop};
      __asm{nop};
      __asm{nop};
    }
  }
}*/
/******************************************************************************************************
*      ƣvoid system_init(void)
*      ܣϵͳʼ
*  ڲ
*  ڲ
*      ڣ2018.4.13
*      ߣ
******************************************************************************************************/
void system_init(void)
{
  //LDOEN=0;
  //ADPCON=0x00;     
  //ADR  =0x00;   //
  //VREFH=0x00;   //ڲοѹ:  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  //ADM  =0x00;   //

  //T0M=0x00;	
  //FT0IE=0; 
 // TM1M =0x00;   
 // TM2M =0x00;
 // PWM1E=0x00;
 // PWM2E=0x00;
  //FGIE=0;
	
  
  //P1   =0x00;
 // P1M  =0xFF;      //0 =  ģʽ   1 =  ģʽ	
//  P1W  =0x00;      
  //P1UR =0x00;      //P_KEY_1  
//  P1PD =0x00;

  
  //P3   =0x00;       //
  //P3M  =0xFF;       //
//  P3W  =0x00;       //
 // P3UR =0x00;       //0 =     1 =  	
//  P3PD =0x00;       //0 =     1 =  
}

